
      subroutine amoeba(p,y,mp,np,ndim,ftol,funk,iter)
      implicit real*8 (a-h,o-z)
      parameter (nmax=500,itmax=500000,tiny=1.0D-10)
      dimension p(mp,np),y(mp),psum(nmax)
      external funk

      iter = 0
 1    do 12 n = 1,ndim
         sum = 0.0D+00
         do 11 m = 1,ndim+1
            sum = sum+p(m,n)
 11      continue
         psum(n) = sum
 12   continue
 2    ilo = 1
      if (y(1) .gt. y(2)) then
         ihi = 1
         inhi = 2
      else
         ihi = 2
         inhi = 1
      endif
      do 13 i = 1,ndim+1
         if (y(i) .le. y(ilo)) ilo = i
         if (y(i) .gt. y(ihi)) then
            inhi = ihi
            ihi = i
         elseif (y(i) .gt. y(inhi)) then
            if (i .ne. ihi) inhi = i
         endif
 13   continue
      rtol = 2.0D+00*dabs(y(ihi)-y(ilo))/(dabs(y(ihi))+
     &       dabs(y(ilo))+tiny)
      if (rtol .lt. ftol) then
         swap = y(1)
         y(1) = y(ilo)
         y(ilo) = swap
         do 14 n = 1,ndim
            swap = p(1,n)
            p(1,n) = p(ilo,n)
            p(ilo,n) = swap
 14      continue
         return
      endif
c      if (iter .ge. itmax) pause 'itmax exceeded in amoeba'
      if (iter .ge. itmax) return
      iter = iter+2
      ytry = amotry(p,y,psum,mp,np,ndim,funk,ihi,-1.0D+00)
      if (ytry .le. y(ilo)) then
         ytry = amotry(p,y,psum,mp,np,ndim,funk,ihi,2.0D+00)
      elseif (ytry .ge. y(inhi)) then
         ysave = y(ihi)
         ytry = amotry(p,y,psum,mp,np,ndim,funk,ihi,0.5D+00)
         if (ytry .ge. ysave) then
            do 16 i = 1,ndim+1
               if (i .ne. ilo) then
                  do 15 j = 1,ndim
                     psum(j) = 0.5D+00*(p(i,j)+p(ilo,j))
                     p(i,j) = psum(j)
 15               continue
                  y(i) = funk(psum)
               endif
 16         continue
            iter = iter+ndim
            goto 1
         endif
      else
         iter = iter-1
      endif
      goto 2

      end

      double precision function amotry(p,y,psum,mp,np,ndim,
     &                                 funk,ihi,fac)
      implicit real*8 (a-h,o-z)
      parameter (nmax=5000)
      dimension p(mp,np),psum(np),y(mp),ptry(nmax)
      external funk

      fac1 = (1.0D+00-fac)/dble(real(ndim))
      fac2 = fac1-fac
      do 11 j = 1,ndim
         ptry(j) = psum(j)*fac1-p(ihi,j)*fac2
 11   continue
      ytry = funk(ptry)
      if (ytry .lt. y(ihi)) then
         y(ihi) = ytry
         do 12 j = 1,ndim
            psum(j) = psum(j)-p(ihi,j)+ptry(j)
            p(ihi,j) = ptry(j)
 12      continue
      endif

      amotry = ytry

      return
      end

!      subroutine dfpmin(p,n,gtol,iter,fret,func,dfunc)
!      implicit real*8 (a-h,o-z)
!      parameter (nmax=500,itmax=200,stpmx=100.0D+00,
!     &           eps=3.0D-08,tolx=4.0D+00*eps)
!      dimension dg(nmax),g(nmax),hdg(nmax),hessin(nmax,nmax),
!     &          pnew(nmax),xi(nmax),p(n)
!      logical check
!      external func,dfunc
!
!      fp = func(p)
!      call dfunc(p,g)
!      sum = 0.0D+00
!      do 12 i = 1,n
!         do 11 j = 1,n
!            hessin(i,j) = 0.0D+00
! 11      continue
!         hessin(i,i) = 1.0D+00
!         xi(i) = -g(i)
!         sum = sum+p(i)*p(i)
! 12   continue
!      stpmax = stpmx*dmax1(dsqrt(sum),float(n))
!
!      do 27 its = 1,itmax
!         iter = its
!         call lnsrch(n,p,fp,g,xi,pnew,fret,stpmax,check,func)
!         fp = fret
!         do 13 i = 1,n
!            xi(i) = pnew(i)-p(i)
!            p(i) = pnew(i)
! 13      continue
!         test = 0.0D+00
!         do 14 i = 1,n
!            temp = dabs(xi(i))/dmax1(dabs(p(i)),1.0D+00)
!            if (temp .gt. test) test = temp
! 14      continue
!         if (test .lt. tolx) return
!         do 15 i = 1,n
!            dg(i) = g(i)
! 15      continue
!         call dfunc(p,g)
!         test = 0.0D+00
!         den = dmax1(fret,1.0D+00)
!         do 16 i = 1,n
!            temp = dabs(g(i))/dmax1(dabs(p(i)),1.0D+00)/den
!            if (temp .gt. test) test = temp
! 16      continue
!         if (test .lt. gtol) return
!         do 17 i = 1,n
!            dg(i) = g(i)-dg(i)
! 17      continue
!         do 19 i = 1,n
!            hdg(i) = 0.0D+00
!            do 18 j = 1,n
!               hdg(i) = hdg(i)+hessin(i,j)*dg(j)
! 18         continue
! 19      continue
!         fac = 0.0D+00
!         fae = 0.0D+00
!         sumdg = 0.0D+00
!         sumxi = 0.0D+00
!         do 21 i = 1,n
!            fac = fac+dg(i)*xi(i)
!            fae = fae+dg(i)*hdg(i)
!            sumdg = sumdg+dg(i)*dg(i)
!            sumxi = sumxi+xi(i)*xi(i)
! 21      continue
!         if (fac .gt. dsqrt(eps*sumdg*sumxi)) then
!            fac = 1.0D+00/fac
!            fad = 1.0D+00/fae
!            do 22 i = 1,n
!               dg(i) = fac*xi(i)-fad*hdg(i)
! 22         continue
!            do 24 i = 1,n
!               do 23 j = 1,n
!                  hessin(i,j) = hessin(i,j)+fac*xi(i)*xi(j)-
!     &                          fad*hdg(i)*hdg(j)+
!     &                          fae*dg(i)*dg(j)
!                  hessin(j,i) = hessin(i,j)
! 23            continue
! 24         continue
!         endif
!         do 26 i = 1,n
!            xi(i) = 0.0D+00
!            do 25 j = 1,n
!               xi(i) = xi(i)-hessin(i,j)*g(j)
! 25         continue
! 26      continue
! 27   continue
!      pause 'too many iterations in dfpmin'
!
!      return
!      end

      subroutine lnsrch(n,xold,fold,g,p,x,f,stpmax,check,func)
      implicit real*8 (a-h,o-z)
      parameter (alf=1.0D-04,tolx=1.0D-10)
      dimension g(n),p(n),x(n),xold(n)
      logical check
      external func

      check = .false.
      sum = 0.0D+00
      do 11 i = 1,n
         sum = sum+p(i)*p(i)
 11   continue
      sum = dsqrt(sum)
      if (sum .gt. stpmax) then
         do 12 i = 1,n
            p(i) = p(i)*stpmax/sum
 12      continue
      endif
      slope = 0.0D+00
      do 13 i = 1,n
         slope = slope+g(i)*p(i)
 13   continue
      if (slope .ge. 0.0D+00) pause 'roundoff error in lnsrch'
      test = 0.0D+00
      do 14 i = 1,n
         temp = dabs(p(i))/dmax1(dabs(xold(i)),1.0D+00)
         if (temp .gt. test) test = temp
 14   continue
      alamin = tolx/test
      alam = 1.0D+00
 1    continue
         do 15 i = 1,n
            x(i) = xold(i)+alam*p(i)
 15      continue
         f = func(x)
         if (alam .lt. alamin) then
            do 16 i = 1,n
               x(i) = xold(i)
 16         continue
            check = .true.
            return
         elseif (f .le. fold+alf*alam*slope) then
            return
         else
            if (alam .eq. 1) then
               tmplam = -slope/(2.0D+00*(f-fold-slope))
            else
               rhs1 = f-fold-alam*slope
               rhs2 = f2-fold-alam2*slope
               a = (rhs1/alam**2-rhs2/alam2**2)/(alam-alam2)
               b = (-alam2*rhs1/alam**2+alam*rhs2/alam**2)/
     &             (alam-alam2)
               if (a .eq. 0.0D+00) then
                  tmplam = -slope/(2.0D+00*b)
               else
                  disc = b*b-3.0D+00*a*slope
                  if (disc .lt. 0.0D+00) then
                     tmplam = 0.5D+00*alam
                  elseif (b .le. 0.0D+00) then
                     tmplam = (-b+dsqrt(disc))/(3.0D+00*a)
                  else
                     tmplam = -slope/(b+dsqrt(disc))
                  endif
               endif
               if (tmplam .gt. 0.5D+00*alam) tmplam = 0.5D+00*alam
            endif
         endif
         alam2 = alam
         f2 = f
         alam = dmax1(tmplam,0.1D+00*alam)
      goto 1
         
      end

      double precision function brent(ax,bx,cx,f,tol,xmin)
      implicit real*8 (a-h,o-z)
      parameter (itmax=500,cgold=0.3819660D+00,zeps=1.0D-10)
      external f

      a = dmin1(ax,cx)
      b = dmax1(ax,cx)
      v = bx
      w = v
      x = v
      e = 0.0D+00
      fx = f(x)
      fv = fx
      fw = fx
      do 11 iter = 1,itmax
         xm = 0.5D+00*(a+b)
         tol1 = tol*dabs(x)+zeps
         tol2 = 2.0D+00*tol1
         if (dabs(x-xm) .le. (tol2-0.5D+00*(b-a))) goto 3
         if (dabs(e) .gt. tol1) then
            r = (x-w)*(fx-fv)
            q = (x-v)*(fx-fw)
            p = (x-v)*q-(x-w)*r
            q = 2.0D+00*(q-r)
            if (q .gt. 0.0D+00) p = -p
            q = dabs(q)
            etemp = e
            e = d
            if (dabs(p) .ge. dabs(0.5D+00*q*etemp) .or.
     &          p .le. q*(a-x) .or. p .ge. q*(b-x)) goto 1
            d = p/q
            u = x+d
            if (u-a .lt. tol2 .or. b-u .lt. tol2)
     &          d = dsign(tol1,xm-x)
            goto 2
         endif
 1       if (x .ge. xm) then
            e = a-x
         else
            e = b-x
         endif
         d = cgold*e
 2       if (dabs(d) .ge. tol1) then
            u = x+d
         else
            u = x+dsign(tol1,d)
         endif
         fu = f(u)
         if (fu .le. fx) then
            if (u .ge. x) then
               a = x
            else
               b = x
            endif
            v = w
            fv = fw
            w = x
            fw = fx
            x = u
            fx = fu
         else
            if (u .lt. x) then
               a = u
            else
               b = u
            endif
            if (fu .le. fw .or. w .eq. x) then
               v = w
               fv = fw
               w = u
               fw = fu
            elseif (fu .le. fv .or. v .eq. x .or. v .eq. w) then
               v = u
               fv = fu
            endif
         endif
 11   continue
      pause 'brent exceeding maximum iterations'
 3    xmin = x
      brent = fx

      return
      end

      subroutine amebsa(p,y,mp,np,ndim,pb,yb,ftol,funk,iter,temptr)
      implicit real*8 (a-h,o-z)
      parameter (nmax=400)
      external funk
      dimension psum(nmax),p(mp,np),pb(np),y(mp)
      common/ambsa/tt,idum

      tt = -temptr
 1    do 12 n = 1,ndim
         sum = 0.0D+00
         do 11 m = 1,ndim+1
            sum = sum+p(m,n)
 11      continue
         psum(n) = sum
 12   continue

 2    ilo = 1
      ihi = 2
      ylo = y(1)+tt*dlog(ran1(idum))
      ynhi = ylo
      yhi = y(2)+tt*dlog(ran1(idum))
      if (ylo .gt. yhi) then
         ihi = 1
         ilo = 2
         ynhi = yhi
         yhi = ylo
         ylo = ynhi
      endif
      do 13 i = 3,ndim+1
         yt = y(i)+tt*dlog(ran1(idum))
         if (yt .le. ylo) then
            ilo = i
            ylo = yt
         endif
         if (yt .gt. yhi) then
            ynhi = yhi
            ihi = i
            yhi = yt
         elseif (yt .gt. ynhi) then
            ynhi = yt
         endif
 13   continue

      rtol = 2.0D+00*dabs(yhi-ylo)/(dabs(yhi)+dabs(ylo))
      if (rtol .lt. ftol .or. iter .lt. 0) then
         swap = y(1)
         y(1) = y(ilo)
         y(ilo) = swap
         do 14 n = 1,ndim
            swap = p(1,n)
            p(1,n) = p(ilo,n)
            p(ilo,n) = swap
 14      continue
         return
      endif

      iter = iter-2
      ytry = amotsa(p,y,psum,mp,np,ndim,pb,yb,funk,ihi,yhi,-1.0D+00)
      if (ytry .le. ylo) then
         ytry = amotsa(p,y,psum,mp,np,ndim,pb,yb,funk,ihi,yhi,2.0D+00)
      elseif (ytry .ge. ynhi) then
         ysave = yhi
         ytry = amotsa(p,y,psum,mp,np,ndim,pb,yb,funk,ihi,yhi,0.5D+00)
         if (ytry .ge. ysave) then
            do 16 i = 1,ndim+1
               if (i .ne. ilo) then
                  do 15 j = 1,ndim
                     psum(j) = 0.5D+00*(p(i,j)+p(ilo,j))
                     p(i,j) = psum(j)
 15               continue
                  y(i) = funk(psum)
               endif
 16         continue
            iter = iter-ndim
            goto 1
         endif
      else
         iter = iter+1
      endif
      goto 2

      end

      double precision function amotsa(p,y,psum,mp,np,ndim,
     &                                 pb,yb,funk,ihi,yhi,fac)
      implicit real*8 (a-h,o-z)
      parameter (nmax=400)
      dimension p(mp,np),pb(np),psum(np),y(mp),ptry(nmax)
      external funk
      common/ambsa/tt,idum

      fac1 = (1.0D+00-fac)/dble(real(ndim))
      fac2 = fac1-fac
      do 11 j = 1,ndim
         ptry(j) = psum(j)*fac1-p(ihi,j)*fac2
 11   continue

      ytry = funk(ptry)
      if (ytry .le. yb) then
         do 12 j = 1,ndim
            pb(j) = ptry(j)
 12      continue
         yb = ytry
      endif

      yflu = ytry-tt*dlog(ran1(idum))
      if (yflu .lt. yhi) then
         y(ihi) = ytry
         yhi = yflu
         do 13 j = 1,ndim
            psum(j) = psum(j)-p(ihi,j)+ptry(j)
            p(ihi,j) = ptry(j)
 13      continue
      endif

      amotsa = yflu
      return
      end

      double precision function ran1(idum)
      implicit real*8 (a-h,o-z)
      parameter (ia=16807,im=2147483647,iq=127773,ir=2836,ntab=32,
     &           ndiv=1+(im-1)/ntab,eps=1.2D-07,rnmx=1.0D+00-eps)
      dimension iv(ntab)
      save iv,iy
      data iv/ntab*0/, iy/0/

      am = 1.0D+00/dble(real(im))
      if (idum .le. 0 .or. iy .eq. 0) then
         idum = max(-idum,1)
         do 11 j = ntab+8,1,-1
            k = idum/iq
            idum = ia*(idum-k*iq)-ir*k
            if (idum .lt. 0) idum = idum+im
            if (j .le. ntab) iv(j) = idum
 11      continue
         iy = iv(1)
      endif
      k = idum/iq
      idum = ia*(idum-k*iq)-ir*k
      if (idum .lt. 0) idum = idum+im
      j = 1+iy/ndiv
      iy = iv(j)
      iv(j) = idum
      ran1 = dmin1(am*dble(real(iy)),rnmx)
      return
      end

      double precision function golden(ax,bx,cx,f,tol,xmin)
	implicit real*8 (a-h,o-z)
	parameter (r=0.61803399D+00,c=1.0D+00-r)
	external f

	x0 = ax
	x3 = cx
	if (dabs(cx-bx) .gt. dabs(bx-ax)) then
	   x1 = bx
	   x2 = bx+c*(cx-bx)
	else
	   x2 = bx
	   x1 = bx-c*(bx-ax)
	endif
	f1 = f(x1)
	f2 = f(x2)

 1    if (dabs(x3-x0) .gt. tol*(dabs(x1)+dabs(x2))) then
         if (f2 .lt. f1) then
	      x0 = x1
	      x1 = x2
	      x2 = r*x1+c*x3
	      f1 = f2
	      f2 = f(x2)
	   else
	      x3 = x2
	      x2 = x1
	      x1 = r*x2+c*x0
	      f2 = f1
	      f1 = f(x1)
	   endif
	   goto 1
	endif

	if (f1 .gt. f2) then
	   golden = f1
	   xmin = x1
	else
	   golden = f2
	   xmin = x2
	endif

	return
	end

      subroutine mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,
     &                  funcs,alamda)
	implicit real*8 (a-h,o-z)
	parameter (mmax=20)
	dimension a(ma),alpha(nca,nca),covar(nca,nca),sig(ndata),ia(ma),
     &          x(ndata),y(ndata),atry(mmax),beta(mmax),da(mmax)
	save ochisq,atry,beta,da,mfit
	external funcs

	if (alamda .lt. 0.0D+00) then
	   mfit = 0
	   do 11 j = 1,ma
	      if (ia(j) .ne. 0) mfit = mfit+1
 11      continue
         alamda = 0.001D+00
	   call mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nca,chisq,funcs)
	   ochisq = chisq
	   do 12 j = 1,ma
	      atry(j) = a(j)
 12      continue
      endif

	do 14 j = 1,mfit
	   do 13 k = 1,mfit
	      covar(j,k) = alpha(j,k)
 13      continue
         covar(j,j) = alpha(j,j)*(1.0D+00+alamda)
	   da(j) = beta(j)
 14   continue

      call gaussj(covar,mfit,nca,da,1,1)
	if (alamda .eq. 0.0D+00) then
	   call covsrt(covar,nca,ma,ia,mfit)
	   call covsrt(alpha,nca,ma,ia,mfit)
	   return
	endif

	j = 0
	do 15 l = 1,ma
	   if (ia(l) .ne. 0) then
	      j = j+1
	      atry(l) = a(l)+da(l)
	   endif
 15   continue
      call mrqcof(x,y,sig,ndata,atry,ia,ma,covar,da,nca,chisq,funcs)
	if (chisq .lt. ochisq) then
	   alamda = 0.1D+00*alamda
	   ochisq = chisq
	   do 17 j = 1,mfit
	      do 16 k = 1,mfit
	         alpha(j,k) = covar(j,k)
 16         continue
            beta(j) = da(j)
 17      continue
         do 18 l = 1,ma
	      a(l) = atry(l)
 18      continue
      else
	   alamda = 10.0D+00*alamda
	   chisq = ochisq
	endif

	return
	end

      subroutine mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nalp,chisq,
     &                  funcs)
	implicit real*8 (a-h,o-z)
      parameter (mmax=20)
	dimension a(ma),alpha(nalp,nalp),beta(ma),sig(ndata),x(ndata),
     &          y(ndata),dyda(mmax),ia(ma)
	external funcs

	mfit = 0
	do 11 j = 1,ma
	   if (ia(j) .ne. 0) mfit = mfit+1
 11   continue

      do 13 j = 1,mfit
	   do 12 k = 1,j
	      alpha(j,k) = 0.0D+00
 12      continue
         beta(j) = 0.0D+00
 13   continue

      chisq = 0.0D+00
	do 16 i = 1,ndata
	   call funcs(x(i),a,ymod,dyda,ma)
	   sig2i = 1.0D+00/(sig(i)*sig(i))
	   dy = y(i)-ymod
	   j = 0
	   do 15 l = 1,ma
	      if (ia(l) .ne. 0) then
               j = j+1
	         wt = dyda(l)*sig2i
	         k = 0
	         do 14 m = 1,l
	            if (ia(m) .ne. 0) then
	               k = k+1
	               alpha(j,k) = alpha(j,k)+wt*dyda(m)
	            endif
 14            continue
               beta(j) = beta(j)+dy*wt
	      endif
 15      continue
         chisq = chisq+dy*dy*sig2i
 16   continue
      
	do 18 j = 2,mfit
	   do 17 k = 1,j-1
	      alpha(k,j) = alpha(j,k)
 17      continue
 18   continue

      return
	end

      subroutine covsrt(covar,npc,ma,ia,mfit)
	implicit real*8 (a-h,o-z)
	dimension covar(npc,npc),ia(ma)

	do 12 i = mfit+1,ma
	   do 11 j = 1,i
	      covar(i,j) = 0.0D+00
	      covar(j,i) = 0.0D+00
 11      continue
 12   continue

      k = mfit
	do 15 j = ma,1,-1
	   if (ia(j) .ne. 0) then
	      do 13 i = 1,ma
	         swap = covar(i,k)
	         covar(i,k) = covar(i,j)
	         covar(i,j) = swap
 13         continue
            do 14 i = 1,ma
	         swap = covar(k,i)
	         covar(k,i) = covar(j,i)
	         covar(j,i) = swap
 14         continue
            k = k-1
	   endif
 15   continue
   
      return
	end

	subroutine gaussj(a,n,np,b,m,mp)
	implicit real*8 (a-h,o-z)
	parameter (nmax=50)
	dimension a(np,np),b(np,mp),indxc(nmax),indxr(nmax),ipiv(nmax)

	do 11 j = 1,n
	   ipiv(j) = 0
 11   continue
      do 22 i = 1,n
	   big = 0.0D+00
	   do 13 j = 1,n
	      if (ipiv(j) .ne. 1) then
	         do 12 k = 1,n
	            if (ipiv(k) .eq. 0) then
	               if (dabs(a(j,k)) .ge. big) then
	                  big = dabs(a(j,k))
	                  irow = j
	                  icol = k
	               endif
	            elseif (ipiv(k) .gt. 1) then
	               pause 'singular matrix in gaussj'
	            endif
 12            continue
            endif
 13      continue
         ipiv(icol) = ipiv(icol)+1

	   if (irow .ne. icol) then
	      do 14 l = 1,n
	         dum = a(irow,l)
	         a(irow,l) = a(icol,l)
	         a(icol,l) = dum
 14         continue
            do 15 l = 1,m
	         dum = b(irow,l)
	         b(irow,l) = b(icol,l)
	         b(icol,l) = dum
 15         continue
         endif

	   indxr(i) = irow
	   indxc(i) = icol
	   if (a(icol,icol) .eq. 0.0D+00) pause 'singular matrix in 
     &                                         gaussj'
	   pivinv = 1.0D+00/a(icol,icol)
	   a(icol,icol) = 1.0D+00
	   do 16 l = 1,n
	      a(icol,l) = a(icol,l)*pivinv
 16      continue
         do 17 l = 1,m
	      b(icol,l) = b(icol,l)*pivinv
 17      continue

         do 21 ll = 1,n
	      if (ll .ne. icol) then
	         dum = a(ll,icol)
	         a(ll,icol) = 0.0D+00
	         do 18 l = 1,n
	            a(ll,l) = a(ll,l)-a(icol,l)*dum
 18            continue
               do 19 l = 1,m
	            b(ll,l) = b(ll,l)-b(icol,l)*dum
 19            continue
            endif
 21      continue
 22   continue
      
      do 24 l = n,1,-1
	   if (indxr(l) .ne. indxc(l)) then
	      do 23 k = 1,n
	         dum = a(k,indxr(l))
	         a(k,indxr(l)) = a(k,indxc(l))
	         a(k,indxc(l)) = dum
 23         continue
         endif
 24   continue

      return
	end

	double precision function dbrent(ax,bx,cx,f,df,tol,xmin)
	implicit real*8 (a-h,o-z)
	parameter (itmax=100,zeps=1.0D-10)
	external df,f
	logical ok1,ok2

	a = dmin1(ax,cx)
	b = dmax1(ax,cx)
	v = bx
	w = v
	x = v
	e = 0.0D+00
	fx = f(x)
	fv = fx
	fw = fx
	dx = df(x)
	dv = dx
	dw = dx

	do 11 iter = 1,itmax
	   xm = 0.5D+00*(a+b)
	   tol1 = tol*dabs(x)+zeps
	   tol2 = 2.0D+00*tol1
	   if (dabs(x-xm) .le. (tol2-0.5D+00*(b-a))) goto 3
	   if (dabs(e) .gt. tol1) then
	      d1 = 2.0D+00*(b-a)
	      d2 = d1
	      if (dw .ne. dx) d1 = (w-x)*dx/(dx-dw)
	      if (dv .ne. dx) d2 = (v-x)*dx/(dx-dv)
	      u1 = x+d1
	      u2 = x+d2
	      ok1 = ((a-u1)*(u1-b) .gt. 0.0D+00) .and. 
     &            (dx*d1 .le. 0.0D+00)
	      ok2 = ((a-u2)*(u2-b) .gt. 0.0D+00) .and.
     &            (dx*d2 .le. 0.0D+00)
	      olde = e
	      e = d
	      if (.not. (ok1 .or. ok2)) then
	         goto 1
	      elseif (ok1 .and. ok2) then
	         if (dabs(d1) .lt. dabs(d2)) then
	            d = d1
	         else
	            d = d2
	         endif
	      elseif (ok1) then
	         d = d1
	      else
	         d = d2
	      endif
	      if (dabs(d) .gt. dabs(0.5D+00*olde)) goto 1
	      u = x+d
	      if (u-a .lt. tol2 .or. b-u .lt. tol2) d = dsign(tol1,xm-x)
	      goto 2
	   endif
 1       if (dx .ge. 0.0D+00) then
            e = a-x
	   else
	      e = b-x
	   endif
	   d = 0.5D+00*e
 2       if (dabs(d) .ge. tol1) then
            u = x+d
	      fu = f(u)
	   else
	      u = x+dsign(tol1,d)
	      fu = f(u)
	      if (fu .gt. fx) goto 3
	   endif
	   du = df(u)
	   if (fu .le. fx) then
	      if (u .ge. x) then
	         a = x
	      else
	         b = x
	      endif
	      v = w
	      fv = fw
	      dv = dw
	      w = x
	      fw = fx
	      dw = dx
	      x = u
	      fx = fu
	      dx = du
	   else
	      if (u .lt. x) then
	         a = u
	      else
	         b = u
	      endif
	      if (fu .le. fw .or. w .eq. x) then
	         v = w
	         fv = fw
	         dv = dw
	         w = u
	         fw = fu
	         dw = du
	      elseif (fu .le. fv .or. v .eq. x .or. v .eq. w) then
	         v = u
	         fv = fu
	         dv = du
	      endif
	   endif
 11   continue
      pause 'dbrent exceeded maximum iterations'
 3    xmin = x
      dbrent = fx
	
	return
	end
